Func Server()
	Opt("TrayOnEventMode", 1)
	Opt("TrayMenuMode", 3)
	TrayCreateItem("Exit")
	TrayItemSetOnEvent(-1, "ServerOnExit")
	TrayCreateItem("About VCTemp...")
	TrayItemSetOnEvent(-1, "ServerOnAbout")
	Opt("TrayIconHide", 0)

	TCPStartup()
	$MainSocket = TCPListen(@IPAddress1, 33850)
	If $MainSocket = -1 Then
		MsgBox(0, "VCTemp:Error", "Failed to listen on port 33850.VCTemp will now exit")
		Exit
	EndIf

	$DLL = DllOpen("GetCoreTempInfo.dll")
	If $DLL=-1 Then
	MsgBox(0,"VCTemp:Error",'Failed to open "GetCoreTempInfo.dll". VCTemp will now exit.')
	Exit
	EndIf
	$Struct = DllStructCreate("uint[256];uint[128];uint;uint;float[256];float;float;float;float;char[100];BOOLEAN;BYTE")

	While 1
		Do
			$ConnectedSocket = TCPAccept($MainSocket)
		Until $ConnectedSocket <> -1



		While 1
			TCPSend($ConnectedSocket, GetTemps($DLL, $Struct))
			If @error Then
				ExitLoop
			EndIf
			Sleep(1000)
		WEnd
	WEnd
EndFunc   ;==>Server

Func ServerOnExit()
	Exit
EndFunc   ;==>ServerOnExit

Func ServerOnAbout()
	TrayTip("VCTemp V" & $VerInfo, "2010 Michael Michta", 5, 1)
EndFunc   ;==>ServerOnAbout

Func GetTemps($hDLL, $vStruct)
	Local $sReturn, $cTempFormat, $iCores, $iCounter
	$Ret=DllCall($hDLL, "BOOLEAN", "fnGetCoreTempInfoAlt", "ptr", DllStructGetPtr($vStruct))
	If @Error Then Return ".ERROR."
	If $Ret[0]<>1 Then Return ".NODATA."
	$iCores = DllStructGetData($vStruct, 3)
	Switch DllStructGetData($vStruct, 11)
		Case 1
			$cTempFormat = "F"
		Case 0
			$cTempFormat = "C"
	EndSwitch
	For $iCounter = 1 To $iCores
		$sReturn &= Round(DllStructGetData($vStruct, 5, $iCounter)) & $cTempFormat
		If $iCounter <> $iCores Then $sReturn &= "  "
	Next
	Return $sReturn
EndFunc   ;==>GetTemps